/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-schunk-sdh-0.5.4-0precise-20150329-2032/msg/TactileMatrix.msg
 *
 */


#ifndef SCHUNK_SDH_MESSAGE_TACTILEMATRIX_H
#define SCHUNK_SDH_MESSAGE_TACTILEMATRIX_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace schunk_sdh
{
template <class ContainerAllocator>
struct TactileMatrix_
{
  typedef TactileMatrix_<ContainerAllocator> Type;

  TactileMatrix_()
    : matrix_id(0)
    , cells_x(0)
    , cells_y(0)
    , tactile_array()  {
    }
  TactileMatrix_(const ContainerAllocator& _alloc)
    : matrix_id(0)
    , cells_x(0)
    , cells_y(0)
    , tactile_array(_alloc)  {
    }



   typedef uint32_t _matrix_id_type;
  _matrix_id_type matrix_id;

   typedef int16_t _cells_x_type;
  _cells_x_type cells_x;

   typedef int16_t _cells_y_type;
  _cells_y_type cells_y;

   typedef std::vector<int16_t, typename ContainerAllocator::template rebind<int16_t>::other >  _tactile_array_type;
  _tactile_array_type tactile_array;




  typedef boost::shared_ptr< ::schunk_sdh::TactileMatrix_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::schunk_sdh::TactileMatrix_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct TactileMatrix_

typedef ::schunk_sdh::TactileMatrix_<std::allocator<void> > TactileMatrix;

typedef boost::shared_ptr< ::schunk_sdh::TactileMatrix > TactileMatrixPtr;
typedef boost::shared_ptr< ::schunk_sdh::TactileMatrix const> TactileMatrixConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::schunk_sdh::TactileMatrix_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace schunk_sdh

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'schunk_sdh': ['/tmp/buildd/ros-hydro-schunk-sdh-0.5.4-0precise-20150329-2032/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'control_msgs': ['/opt/ros/hydro/share/control_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::schunk_sdh::TactileMatrix_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::schunk_sdh::TactileMatrix_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::schunk_sdh::TactileMatrix_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ab718b6c1d4d719110707994d2e325e4";
  }

  static const char* value(const ::schunk_sdh::TactileMatrix_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xab718b6c1d4d7191ULL;
  static const uint64_t static_value2 = 0x10707994d2e325e4ULL;
};

template<class ContainerAllocator>
struct DataType< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
{
  static const char* value()
  {
    return "schunk_sdh/TactileMatrix";
  }

  static const char* value(const ::schunk_sdh::TactileMatrix_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint32 matrix_id\n\
int16 cells_x\n\
int16 cells_y\n\
int16[] tactile_array\n\
";
  }

  static const char* value(const ::schunk_sdh::TactileMatrix_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.matrix_id);
      stream.next(m.cells_x);
      stream.next(m.cells_y);
      stream.next(m.tactile_array);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct TactileMatrix_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::schunk_sdh::TactileMatrix_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::schunk_sdh::TactileMatrix_<ContainerAllocator>& v)
  {
    s << indent << "matrix_id: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.matrix_id);
    s << indent << "cells_x: ";
    Printer<int16_t>::stream(s, indent + "  ", v.cells_x);
    s << indent << "cells_y: ";
    Printer<int16_t>::stream(s, indent + "  ", v.cells_y);
    s << indent << "tactile_array[]" << std::endl;
    for (size_t i = 0; i < v.tactile_array.size(); ++i)
    {
      s << indent << "  tactile_array[" << i << "]: ";
      Printer<int16_t>::stream(s, indent + "  ", v.tactile_array[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // SCHUNK_SDH_MESSAGE_TACTILEMATRIX_H
